------------------------------------------------------------------------
-- This software is provided as is in the hope that it might be found
-- useful.
-- You may use and modify it freely provided you keep this copyright
-- notice unchanged and mark modifications appropriately.
--
-- Bug reports and proposals for improvements are welcome. Please send
-- them to the eMail address below.
--
-- Christoph Karl Walter Grein
-- Hauptstr. 42
-- D-86926 Greifenberg
-- Germany
--
-- eMail: Christ-Usch.Grein@T-Online.de
--
-- Copyright (c) 1998 Christoph Karl Walter Grein
------------------------------------------------------------------------

with Ada.Direct_IO;

function Lexer.Read_File (Name: in String) return String_Pointer is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      25 October 1998
  --====================================================================
  -- Read a file and return its contents via a pointer.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  25.10.1998
  --====================================================================

  package Character_Direct_IO is new Ada.Direct_IO (Character);
  use     Character_Direct_IO;

  Original: Character_Direct_IO.File_Type;
  Contents: String_Pointer;

begin

  Open (Original, In_File, Name);

  Contents := new String (1 .. Integer (Size (Original)));

  for i in Contents'Range loop
    Read (Original, Contents (i));
  end loop;

  Character_Direct_IO.Close (Original);

  return Contents;

end Lexer.Read_File;
